﻿OreCrusherRunOnce = 0;
OreCrusherEventFrame = CreateFrame("Frame")
OreCrusherEventFrame:SetScript("OnEvent", function(this, event, ...)
  OreCrusherEvents[event](...)
end)
OreCrusherEventFrame:RegisterEvent("ADDON_LOADED")
OreCrusherEvents = {};
function OreCrusherEvents.ADDON_LOADED(addon)
	if addon ~= "OreCrusher" then return end
	-- Default saved variables
	if not OreCrusherPriceDB then
		OreCrusherPriceDB = {} -- fresh start
	end
	if not OreCrusherDB then
		OreCrusherDB = {} -- fresh start
	end
	if not OreCrusherDB.DECheck then OreCrusherDB.DECheck = 0 end
	if not OreCrusherDB.DEPct then OreCrusherDB.DEPct = 10 end
	if OreCrusherDB.DEPct == "" then OreCrusherDB.DEPct = 10 end
	if not OreCrusherDB.XmuteCheck then OreCrusherDB.XmuteCheck = 0 end
	if not OreCrusherDB.RareCheck then OreCrusherDB.RareCheck = 0 end
	if not OreCrusherDB.RarePct then OreCrusherDB.RarePct = 10 end
	if OreCrusherDB.RarePct == "" then OreCrusherDB.RarePct = 10 end
	if not OreCrusherDB.UIScale then OreCrusherDB.UIScale = 75 end
	if not OreCrusherDB.PriceDB then 
		if AucAdvanced then
			OreCrusherDB.PriceDB = "Auctioneer"
			print("OreCrusher: Setting Price DB to Auctioneer");
		elseif AuctionatorLoaded then
			OreCrusherDB.PriceDB = "Auctionator"
			print("OreCrusher: Setting Price DB to Auctionator");
		elseif AuctionLite then
			OreCrusherDB.PriceDB = "AuctionLite"
			print("OreCrusher: Setting Price DB to AuctionLite");
		elseif vendor then
			OreCrusherDB.PriceDB = "AuctionMaster"
			print("OreCrusher: Setting Price DB to AuctionMaster");
		elseif TSMAPI then
			OreCrusherDB.PriceDB = "TradeSkillMaster"
			print("OreCrusher: Setting Price DB to TradeSkillMaster_AucDB");
		elseif Ace3 then
			OreCrusherDB.PriceDB = "OreCrusherPriceDB"
			OC_Scan:Show();
			print("OreCrusher: Setting Price DB to OreCrusherPriceDB");
		end
	end
	OreCrusherEventFrame:UnregisterEvent("ADDON_LOADED");
	
	local cb_init_fn = function()
		  local info
		  info = {}
		  info.text = "Auctioneer"
		  info.isNotRadio = true
		  info.func = function() UIDropDownMenu_SetSelectedID(OC_DBCombo, 1, 0); OreCrusherDB.PriceDB = "Auctioneer" OC_Scan:Hide(); print("OreCrusher: Setting Price DB to Auctioneer"); end
		  if OreCrusherDB.PriceDB == "Auctioneer" then info.checked = true end
		  if not AucAdvanced then info.disabled = true end
		  UIDropDownMenu_AddButton(info);
		  info = {}
		  info.text = "Auctionator"
		  info.isNotRadio = true
		  info.func = function() UIDropDownMenu_SetSelectedID(OC_DBCombo, 2, 0); OreCrusherDB.PriceDB = "Auctionator" OC_Scan:Hide(); print("OreCrusher: Setting Price DB to Auctionator"); end
		  if OreCrusherDB.PriceDB == "Auctionator" then info.checked = true end
		  if not AuctionatorLoaded then info.disabled = true end
		  UIDropDownMenu_AddButton(info);
		  info = {}
		  info.text = "AuctionLite"
		  info.isNotRadio = true
		  info.func = function() UIDropDownMenu_SetSelectedID(OC_DBCombo, 3, 0); OreCrusherDB.PriceDB = "AuctionLite" OC_Scan:Hide(); print("OreCrusher: Setting Price DB to AuctionLite"); end
		  if OreCrusherDB.PriceDB == "AuctionLite" then info.checked = true end
		  if not AuctionLite then info.disabled = true end
		  UIDropDownMenu_AddButton(info);
		  info = {}
		  info.text = "AuctionMaster"
		  info.isNotRadio = true
		  info.func = function() UIDropDownMenu_SetSelectedID(OC_DBCombo, 4, 0); OreCrusherDB.PriceDB = "AuctionMaster" OC_Scan:Hide(); print("OreCrusher: Setting Price DB to AuctionMaster"); end
		  if OreCrusherDB.PriceDB == "AuctionMaster" then info.checked = true end
		  if not vendor then info.disabled = true end
		  UIDropDownMenu_AddButton(info);
		  info = {}
		  info.text = "TradeSkillMaster"
		  info.isNotRadio = true
		  info.func = function() UIDropDownMenu_SetSelectedID(OC_DBCombo, 5, 0); OreCrusherDB.PriceDB = "TradeSkillMaster" OC_Scan:Hide(); print("OreCrusher: Setting Price DB to TradeSkillMaster_AucDB"); end
		  if OreCrusherDB.PriceDB == "TradeSkillMaster" then info.checked = true end
		  if not TSMAPI then info.disabled = true end
		  UIDropDownMenu_AddButton(info);
		  info = {}
		  info.text = "OreCrusherPriceDB"
		  info.isNotRadio = true
		  info.func = function() UIDropDownMenu_SetSelectedID(OC_DBCombo, 6, 0); OreCrusherDB.PriceDB = "OreCrusherPriceDB" OC_Scan:Show(); print("OreCrusher: Setting Price DB to OreCrusherPriceDB"); end
		  if OreCrusherDB.PriceDB == "OreCrusherPriceDB" then info.checked = true end
		  if not Ace3 then info.disabled = true end
		  UIDropDownMenu_AddButton(info);

	end
	UIDropDownMenu_Initialize(OC_DBCombo, cb_init_fn);
	if OreCrusherDB.PriceDB == "OreCrusherPriceDB" then OC_Scan:Show() end
	OC_RarePct:SetText(OreCrusherDB.RarePct);
	OC_RareCheck:SetChecked(OreCrusherDB.RareCheck);
	OC_DEPct:SetText(OreCrusherDB.DEPct);
	OC_DECheck:SetChecked(OreCrusherDB.DECheck);
	OC_XmuteCheck:SetChecked(OreCrusherDB.XmuteCheck);
	OC_UIScaleSlider:SetValue(OreCrusherDB.UIScale);
	OC_DBComboText:SetText(OreCrusherDB.PriceDB);
	OreCrusherForm:SetScale(OreCrusherDB.UIScale/100);
	OreCrusherDE:SetScale(OreCrusherDB.UIScale/100);
	OreCrusherTransmute:SetScale(OreCrusherDB.UIScale/100);
	OreCrusherOptions:SetScale(OreCrusherDB.UIScale/100);
  end
  

function OreCrusher_Obsidium()
	if OC_ObsidiumNS:GetNumber() == nil or OC_ObsidiumNS:GetNumber() == 0 then return end
	if OreCrusherDB.RarePct == nil then OreCrusherDB.RarePct = 10 end
	if OreCrusherDB.RarePct == nil then OreCrusherDB.RarePct = 10 end
	OreCrusherRunOnce = 1;
	OreCrusher_RawValue("obs");
	OreCrusher_DE();
	OreCrusher_Xmute();
	OreCrusher_MaxGold();
	OreCrusher_MaxStackPrice();
end

function OreCrusher_Elementium()
	if OC_ElementiumNS:GetNumber() == nil or OC_ElementiumNS:GetNumber() == 0 then return end
	if OreCrusherDB.RarePct == nil then OreCrusherDB.RarePct = 10 end
	if OreCrusherDB.RarePct == nil then OreCrusherDB.RarePct = 10 end
	OreCrusherRunOnce = 1;
	OreCrusher_RawValue("ele");
	OreCrusher_DE();
	OreCrusher_Xmute();
	OreCrusher_MaxGold();
	OreCrusher_MaxStackPrice();
end

function OreCrusher_Pyrite()
	if OC_PyriteNS:GetNumber() == nil or OC_PyriteNS:GetNumber() == 0 then return end
	if OreCrusherDB.RarePct == nil then OreCrusherDB.RarePct = 10 end
	if OreCrusherDB.RarePct == nil then OreCrusherDB.RarePct = 10 end
	OreCrusherRunOnce = 1;
	OreCrusher_RawValue("pyr");
	OreCrusher_DE();
	OreCrusher_Xmute();
	OreCrusher_MaxGold();
	OreCrusher_MaxStackPrice();
end

function OreCrusher_UIScale()
	if not OreCrusherDB then return end;
	if OreCrusherDB.UIScale == OC_UIScaleSlider:GetValue() then return end;
	OreCrusherDB.UIScale = OC_UIScaleSlider:GetValue();
	OreCrusherForm:SetScale(OreCrusherDB.UIScale/100);
	OreCrusherDE:SetScale(OreCrusherDB.UIScale/100);
	OreCrusherTransmute:SetScale(OreCrusherDB.UIScale/100);
end

function OreCrusher_OptionsScale()
	OreCrusherOptions:SetScale(OreCrusherDB.UIScale/100);
end

function OC_XmuteCheckUpdate()
	if OreCrusherDB.XmuteCheck == 0 then
		OreCrusherDB.XmuteCheck = 1
	else
		OreCrusherDB.XmuteCheck = 0
	end
	if OreCrusherRunOnce == 1 then
		OreCrusher_Xmute();
		OreCrusher_MaxGold();
		OreCrusher_MaxStackPrice();
	end
end

function OC_RareCheckUpdate()
	if OreCrusherDB.RareCheck == 0 then
		OreCrusherDB.RareCheck = 1
	else
		OreCrusherDB.RareCheck = 0
	end
	if OreCrusherRunOnce == 1 then
		OreCrusher_DE();
		OreCrusher_Xmute();
		OreCrusher_MaxGold();
		OreCrusher_MaxStackPrice();
	end
end

function OC_RarePctUpdate()
	if OC_RarePct:GetText() == "" then return end
	OreCrusherDB.RarePct = OC_RarePct:GetText();
	if OreCrusherRunOnce == 1 then
		OreCrusher_DE();
		OreCrusher_Xmute();
		OreCrusher_MaxGold();
		OreCrusher_MaxStackPrice();
	end
end

function OC_DECheckUpdate()
	if OreCrusherDB.DECheck == 0 then
		OreCrusherDB.DECheck = 1
	else
		OreCrusherDB.DECheck = 0
	end
	if OreCrusherRunOnce == 1 then
		OreCrusher_DE();
		OreCrusher_MaxGold();
		OreCrusher_MaxStackPrice();
	end
end

function OC_DEPctUpdate()
	if OC_DEPct:GetText() == "" then return end
		OreCrusherDB.DEPct = OC_DEPct:GetText();
	if OreCrusherRunOnce == 1 and OreCrusherDB.DEPct ~= "" then
		OreCrusher_DE();
		OreCrusher_MaxGold();
		OreCrusher_MaxStackPrice();
	end
end

function OreCrusher_RawValue(oreType)
	--OC_AmbRawGLabel:SetText("999"); <da syntex 4 tese
	if oreType == 'obs' then 
		rvPPS = OC_ObsidiumPPS:GetNumber() or 0;
		rvNS = OC_ObsidiumNS:GetNumber() or 0;
		
		--Amounts for obsidium
		AmbAmt = rvNS*.0125*1*4
		OC_AmbAmtLabel:SetText(AmbAmt);
		DemAmt = rvNS*.0125*1*4
		OC_DemAmtLabel:SetText(DemAmt);
		DreAmt = rvNS*.0125*1*4
		OC_DreAmtLabel:SetText(DreAmt);
		EmbAmt = rvNS*.0125*1*4
		OC_EmbAmtLabel:SetText(EmbAmt);
		InfAmt = rvNS*.0125*1*4
		OC_InfAmtLabel:SetText(InfAmt);
		OceAmt = rvNS*.0125*1*4
		OC_OceAmtLabel:SetText(OceAmt);
		AliAmt = rvNS*.25*1*4
		OC_AliAmtLabel:SetText(AliAmt);
		CarAmt = rvNS*.25*1*4
		OC_CarAmtLabel:SetText(CarAmt);
		HesAmt = rvNS*.25*1*4
		OC_HesAmtLabel:SetText(HesAmt);
		JasAmt = rvNS*.25*1*4
		OC_JasAmtLabel:SetText(JasAmt);
		NigAmt = rvNS*.25*1*4
		OC_NigAmtLabel:SetText(NigAmt);
		ZepAmt = rvNS*.25*1*4
		OC_ZepAmtLabel:SetText(ZepAmt);
		VolAmt = 0
		OC_VolAmtLabel:SetText(VolAmt);
	elseif oreType == 'ele' then 
		rvPPS = OC_ElementiumPPS:GetNumber() or 0;
		rvNS = OC_ElementiumNS:GetNumber() or 0;
		
		--Amounts for elementium
		AmbAmt = rvNS*.04*1*4
		OC_AmbAmtLabel:SetText(AmbAmt);
		DemAmt = rvNS*.04*1*4
		OC_DemAmtLabel:SetText(DemAmt);
		DreAmt = rvNS*.04*1*4
		OC_DreAmtLabel:SetText(DreAmt);
		EmbAmt = rvNS*.04*1*4
		OC_EmbAmtLabel:SetText(EmbAmt);
		InfAmt = rvNS*.04*1*4
		OC_InfAmtLabel:SetText(InfAmt);
		OceAmt = rvNS*.04*1*4
		OC_OceAmtLabel:SetText(OceAmt);
		AliAmt = rvNS*.18*1*4
		OC_AliAmtLabel:SetText(AliAmt);
		CarAmt = rvNS*.18*1*4
		OC_CarAmtLabel:SetText(CarAmt);
		HesAmt = rvNS*.18*1*4
		OC_HesAmtLabel:SetText(HesAmt);
		JasAmt = rvNS*.18*1*4
		OC_JasAmtLabel:SetText(JasAmt);
		NigAmt = rvNS*.18*1*4
		OC_NigAmtLabel:SetText(NigAmt);
		ZepAmt = rvNS*.18*1*4
		OC_ZepAmtLabel:SetText(ZepAmt);
		VolAmt = 0
		OC_VolAmtLabel:SetText(VolAmt);
	elseif oreType == 'pyr' then 
		rvPPS = OC_PyritePPS:GetNumber() or 0;
		rvNS = OC_PyriteNS:GetNumber() or 0;
		
		--Amounts for pyrite
		AmbAmt = rvNS*.08*1*4
		OC_AmbAmtLabel:SetText(AmbAmt);
		DemAmt = rvNS*.08*1*4
		OC_DemAmtLabel:SetText(DemAmt);
		DreAmt = rvNS*.08*1*4
		OC_DreAmtLabel:SetText(DreAmt);
		EmbAmt = rvNS*.08*1*4
		OC_EmbAmtLabel:SetText(EmbAmt);
		InfAmt = rvNS*.08*1*4
		OC_InfAmtLabel:SetText(InfAmt);
		OceAmt = rvNS*.08*1*4
		OC_OceAmtLabel:SetText(OceAmt);
		AliAmt = rvNS*.16*1*4
		OC_AliAmtLabel:SetText(AliAmt);
		CarAmt = rvNS*.16*1*4
		OC_CarAmtLabel:SetText(CarAmt);
		HesAmt = rvNS*.16*1*4
		OC_HesAmtLabel:SetText(HesAmt);
		JasAmt = rvNS*.16*1*4
		OC_JasAmtLabel:SetText(JasAmt);
		NigAmt = rvNS*.16*1*4
		OC_NigAmtLabel:SetText(NigAmt);
		ZepAmt = rvNS*.16*1*4
		OC_ZepAmtLabel:SetText(ZepAmt);
		VolAmt = rvNS*1*2*4
		OC_VolAmtLabel:SetText(VolAmt);
	end
	
	--RawValues
	OreCrusher_PriceCheck();
	
	AmbRaw = AmbAmt*amberjewel
	OC_AmbRawGLabel:SetText(OC_GS(AmbRaw, 1));
	OC_AmbRawSLabel:SetText(OC_GS(AmbRaw, 2));
	DemRaw = DemAmt*demonseye
	OC_DemRawGLabel:SetText(OC_GS(DemRaw, 1));
	OC_DemRawSLabel:SetText(OC_GS(DemRaw, 2));
	DreRaw = DreAmt*dreamemerald
	OC_DreRawGLabel:SetText(OC_GS(DreRaw, 1));
	OC_DreRawSLabel:SetText(OC_GS(DreRaw, 2));
	EmbRaw = EmbAmt*embertopaz
	OC_EmbRawGLabel:SetText(OC_GS(EmbRaw, 1));
	OC_EmbRawSLabel:SetText(OC_GS(EmbRaw, 2));
	InfRaw = InfAmt*infernoruby
	OC_InfRawGLabel:SetText(OC_GS(InfRaw, 1));
	OC_InfRawSLabel:SetText(OC_GS(InfRaw, 2));
	OceRaw = OceAmt*oceansapphire
	OC_OceRawGLabel:SetText(OC_GS(OceRaw, 1));
	OC_OceRawSLabel:SetText(OC_GS(OceRaw, 2));
	AliRaw = AliAmt*alicite
	OC_AliRawGLabel:SetText(OC_GS(AliRaw, 1));
	OC_AliRawSLabel:SetText(OC_GS(AliRaw, 2));
	CarRaw = CarAmt*carnelian
	OC_CarRawGLabel:SetText(OC_GS(CarRaw, 1));
	OC_CarRawSLabel:SetText(OC_GS(CarRaw, 2));
	HesRaw = HesAmt*hessonite
	OC_HesRawGLabel:SetText(OC_GS(HesRaw, 1));
	OC_HesRawSLabel:SetText(OC_GS(HesRaw, 2));
	JasRaw = JasAmt*jasper
	OC_JasRawGLabel:SetText(OC_GS(JasRaw, 1));
	OC_JasRawSLabel:SetText(OC_GS(JasRaw, 2));
	NigRaw = NigAmt*nightstone
	OC_NigRawGLabel:SetText(OC_GS(NigRaw, 1));
	OC_NigRawSLabel:SetText(OC_GS(NigRaw, 2));
	ZepRaw = ZepAmt*zephyrite
	OC_ZepRawGLabel:SetText(OC_GS(ZepRaw, 1));
	OC_ZepRawSLabel:SetText(OC_GS(ZepRaw, 2));
	VolRaw = VolAmt*volearth
	OC_VolRawGLabel:SetText(OC_GS(VolRaw, 1));
	OC_VolRawSLabel:SetText(OC_GS(VolRaw, 2));
	TotalRaw = AmbRaw + DemRaw + DreRaw + EmbRaw + InfRaw + OceRaw + AliRaw + CarRaw + HesRaw + JasRaw + NigRaw + ZepRaw + VolRaw
	OC_TotalRawGLabel:SetText(OC_GS(TotalRaw, 1));
	OC_TotalRawSLabel:SetText(OC_GS(TotalRaw, 2));
	OC_OreCostGLabel:SetText(math.floor(rvPPS*rvNS));
	if OreCrusherDB.RareCheck == 1 then
		RareTotal = (AmbRaw + DemRaw + DreRaw + EmbRaw + InfRaw + OceRaw) * (1 + OreCrusherDB.RarePct * .01)
	else
		RareTotal = (AmbRaw + DemRaw + DreRaw + EmbRaw + InfRaw + OceRaw)
	end
end

function OreCrusher_HideTooltip()
	GameTooltip:Hide();
end
function OreCrusher_RawValueTooltip(itemId, sender, itemId2)
	local price
	local itemName = select(1, GetItemInfo(itemId)) or "UNKNOWN ITEM"
	local itemName2 
	if itemId2 ~= nil then itemName2 = select(1, GetItemInfo(itemId2)) or "UNKNOWN ITEM" end
	
	if OreCrusherRunOnce == 1 then
		price = OreCrusherPriceDB["Price"..itemId]
		if itemId2 ~= nil then price2 = OreCrusherPriceDB["Price"..itemId2] end
	else 
		price = 0
		price2 = 0
	end
	GameTooltip:ClearLines();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
	if sender == "main" or sender == "de" then 
		if itemId == 52327 then
			GameTooltip:AddLine("Single Earthy Value: |cffffffff" .. OC_GS(price, 1) .. "|cffffd700g|cffffffff" .. OC_GS(price, 2) .. "|cffc0c0c0s");
		else
			GameTooltip:AddLine("Single " .. itemName .. " Value: |cffffffff" .. OC_GS(price, 1) .. "|cffffd700g|cffffffff" .. OC_GS(price, 2) .. "|cffc0c0c0s");
		end
	elseif sender == "x" then
		GameTooltip:AddLine("Single " .. itemName .. " Value: |cffffffff" .. OC_GS(price, 1) .. "|cffffd700g|cffffffff" .. OC_GS(price, 2) .. "|cffc0c0c0s");
		GameTooltip:AddLine("Single " .. itemName2 .. " Value: |cffffffff" .. OC_GS(price2, 1) .. "|cffffd700g|cffffffff" .. OC_GS(price2, 2) .. "|cffc0c0c0s");
	end
	GameTooltip:Show();
end
function OreCrusher_RareXTooltip(itemId, sender, itemId2)
	local price
	local itemName = select(1, GetItemInfo(itemId)) or "UNKNOWN ITEM"
	if OreCrusherRunOnce == 1 then
		price = OreCrusherPriceDB["Price"..itemId]
	else 
		price = 0
	end
	GameTooltip:ClearLines();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
	GameTooltip:AddLine("Single " .. itemName .. " Value: |cffffffff" .. OC_GS(price, 1) .. "|cffffd700g|cffffffff" .. OC_GS(price, 2) .. "|cffc0c0c0s");
	GameTooltip:Show();
end
function OreCrusher_HypTooltip(sender)
	GameTooltip:ClearLines();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
	GameTooltip:AddLine("Single Hypno Value: |cffffffff" .. OC_GS(hypnoticdust or 0, 1) .. "|cffffd700g|cffffffff" .. OC_GS(hypnoticdust or 0, 2) .. "|cffc0c0c0s");
	GameTooltip:Show();
end
function OreCrusher_GceTooltip(sender)
	GameTooltip:ClearLines();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
	GameTooltip:AddLine("Single Ethereal Value: |cffffffff" .. OC_GS(greaterceles or 0, 1) .. "|cffffd700g|cffffffff" .. OC_GS(greaterceles or 0, 2) .. "|cffc0c0c0s");
	GameTooltip:Show();
end
function OreCrusher_DETooltip(sender)
	DERaw = (DETotalRaw or 0)
	DEAllRaw = (RareTotal or 0) + (VolRaw or 0) + (AliTotalRaw or 0) + (CarTotalRaw or 0) + (HesTotalRaw or 0) + (JasTotalRaw or 0) + (NigTotalRaw or 0) + (ZepTotalRaw or 0)
	GameTooltip:ClearLines();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
	GameTooltip:AddLine("Disenchanting all items: |cffffffff" .. OC_GS(DEAllRaw, 1) .. "|cffffd700g|cffffffff" .. OC_GS(DEAllRaw, 2) .. "|cffc0c0c0s|r|r (Profit: |cffffffff" .. OC_GS(DEAllRaw - (((rvPPS or 0)*(rvNS or 0))*10000), 1) .. "|cffffd700g|cffffffff" .. OC_GS(DEAllRaw - (((rvPPS or 0)*(rvNS or 0))*10000), 2) .. "|cffc0c0c0s|r|r)");
	GameTooltip:AddLine(" ");
	GameTooltip:AddLine("Following recommendations: |cffffffff" .. OC_GS(DERaw, 1) .. "|cffffd700g|cffffffff" .. OC_GS(DERaw, 2) .. "|cffc0c0c0s|r|r (Profit: |cffffffff" .. OC_GS(DERaw - (((rvPPS or 0)*(rvNS or 0))*10000), 1) .. "|cffffd700g|cffffffff" .. OC_GS(DERaw - (((rvPPS or 0)*(rvNS or 0))*10000), 2) .. "|cffc0c0c0s|r|r)");
	GameTooltip:Show();
end
function OreCrusher_XmuteTooltip(sender)
	XmuteRaw = (SDXmuteTotalRaw or 0)
	XmuteAllRaw = (RareTotal or 0) + (VolRaw or 0) + (AliXTotalRaw or 0) + (CarXTotalRaw or 0) + (HesXTotalRaw or 0) + (JasXTotalRaw or 0) + (NigXTotalRaw or 0) + (ZepXTotalRaw or 0)
	XmuteRec = (RareTotal or 0) + (VolRaw or 0) + (AliXTotal or 0) + (CarXTotal or 0) + (HesXTotal or 0) + (JasXTotal or 0) + (NigXTotal or 0) + (ZepXTotal or 0)
	GameTooltip:ClearLines();
	GameTooltip:SetOwner(UIParent, "ANCHOR_CURSOR")
	GameTooltip:AddLine("|cffffffff" .. (XmuteAmt or 0) .. " |cffffc100Shadowspirit Diamonds @ |cffffffff" .. OC_GS(shadowspirit or 0, 1) .. "|cffffd700g|cffffffff" .. OC_GS(shadowspirit or 0, 2) .. "|cffc0c0c0s |cffffc100each");
	GameTooltip:AddLine("Shadowspirit Transmutes: |cffffffff" .. OC_GS(XmuteRaw, 1) .. "|cffffd700g|cffffffff" .. OC_GS(XmuteRaw, 2) .. "|cffc0c0c0s|r|r (Profit: |cffffffff" .. OC_GS(XmuteRaw - (((rvPPS or 0)*(rvNS or 0))*10000), 1) .. "|cffffd700g|cffffffff" .. OC_GS(XmuteRaw - (((rvPPS or 0)*(rvNS or 0))*10000), 2) .. "|cffc0c0c0s|r|r)");
	GameTooltip:AddLine(" ");
	GameTooltip:AddLine("TRANSMUTE.  EVERYTHING.: |cffffffff" .. OC_GS(XmuteAllRaw, 1) .. "|cffffd700g|cffffffff" .. OC_GS(XmuteAllRaw, 2) .. "|cffc0c0c0s|r|r (Profit: |cffffffff" .. OC_GS(XmuteAllRaw - (((rvPPS or 0)*(rvNS or 0))*10000), 1) .. "|cffffd700g|cffffffff" .. OC_GS(XmuteAllRaw - (((rvPPS or 0)*(rvNS or 0))*10000), 2) .. "|cffc0c0c0s|r|r)");
	GameTooltip:AddLine(" ");
	GameTooltip:AddLine("Following recommendations: |cffffffff" .. OC_GS(XmuteRec, 1) .. "|cffffd700g|cffffffff" .. OC_GS(XmuteRec, 2) .. "|cffc0c0c0s|r|r (Profit: |cffffffff" .. OC_GS(XmuteRec - (((rvPPS or 0)*(rvNS or 0))*10000), 1) .. "|cffffd700g|cffffffff" .. OC_GS(XmuteRec - (((rvPPS or 0)*(rvNS or 0))*10000), 2) .. "|cffc0c0c0s|r|r)");
	GameTooltip:Show();
end

function OreCrusher_DE()
	if OreCrusherDB.RareCheck == 1 then
		RareTotal = (AmbRaw + DemRaw + DreRaw + EmbRaw + InfRaw + OceRaw) * (1 + OreCrusherDB.RarePct * .01)
	else
		RareTotal = (AmbRaw + DemRaw + DreRaw + EmbRaw + InfRaw + OceRaw)
	end
	--REMEMBER SETTING COST!!<done.
	--REMOVE THAT LINE!!!<don
	--Alicite
	AliCraft = AliAmt/2
	AliHyp = AliCraft*.75*2
	OC_AliHypAmtLabel:SetText(AliHyp);
	AliHypRaw = AliHyp * hypnoticdust
	OC_AliHypGLabel:SetText(OC_GS(AliHypRaw, 1));
	OC_AliHypSLabel:SetText(OC_GS(AliHypRaw, 2));
	AliGce = AliCraft*.25*(2/3)
	OC_AliGceAmtLabel:SetText(AliGce);
	AliGceRaw = AliGce * greaterceles
	OC_AliGceGLabel:SetText(OC_GS(AliGceRaw, 1));
	OC_AliGceSLabel:SetText(OC_GS(AliGceRaw, 2));
	if OreCrusherDB.DECheck == 1 then
		AliTotalRaw = ((AliGceRaw + AliHypRaw) * ((1 + OreCrusherDB.DEPct * .01))) - (AliCraft * 12000)
	else
		AliTotalRaw = (AliGceRaw + AliHypRaw) - (AliCraft * 12000)
	end
	OC_AliTotalGLabel:SetText(OC_GS(AliTotalRaw, 1));
	OC_AliTotalSLabel:SetText(OC_GS(AliTotalRaw, 2));
	AliGemWorth = AliTotalRaw/AliAmt
	OC_AliWorthGLabel:SetText(OC_GS(AliGemWorth, 1));
	OC_AliWorthSLabel:SetText(OC_GS(AliGemWorth, 2));
	if (alicite < 52500) and (AliGemWorth < 52500) then
		OC_AliRecLabel:SetText("Vendor Raw");
		AliTotal = AliAmt * 50000
	elseif AliGemWorth < alicite then
		OC_AliRecLabel:SetText("Auction Raw");
		AliTotal = AliRaw
	elseif AliGemWorth > alicite then
		OC_AliRecLabel:SetText("DE");
		AliTotal = AliTotalRaw
	end
	--Carnelian
	CarCraft = CarAmt/3
	CarHyp = CarCraft*.25*3.5
	OC_CarHypAmtLabel:SetText(CarHyp);
	CarHypRaw = CarHyp * hypnoticdust
	OC_CarHypGLabel:SetText(OC_GS(CarHypRaw, 1));
	OC_CarHypSLabel:SetText(OC_GS(CarHypRaw, 2));
	CarGce = CarCraft*.75*2.5
	OC_CarGceAmtLabel:SetText(CarGce);
	CarGceRaw = CarGce * greaterceles
	OC_CarGceGLabel:SetText(OC_GS(CarGceRaw, 1));
	OC_CarGceSLabel:SetText(OC_GS(CarGceRaw, 2));
	if OreCrusherDB.DECheck == 1 then
		CarTotalRaw = ((CarGceRaw + CarHypRaw) * ((1 + OreCrusherDB.DEPct * .01))) - (CarCraft * 36000)
	else
		CarTotalRaw = (CarGceRaw + CarHypRaw) - (CarCraft * 36000)
	end
	OC_CarTotalGLabel:SetText(OC_GS(CarTotalRaw, 1));
	OC_CarTotalSLabel:SetText(OC_GS(CarTotalRaw, 2));
	CarGemWorth = CarTotalRaw/CarAmt
	OC_CarWorthGLabel:SetText(OC_GS(CarGemWorth, 1));
	OC_CarWorthSLabel:SetText(OC_GS(CarGemWorth, 2));
	if (carnelian < 52500) and (CarGemWorth < 52500) then
		OC_CarRecLabel:SetText("Vendor Raw");
		CarTotal = CarAmt * 50000
	elseif CarGemWorth < carnelian then
		OC_CarRecLabel:SetText("Auction Raw");
		CarTotal = CarRaw
	elseif CarGemWorth > carnelian then
		OC_CarRecLabel:SetText("DE");
		CarTotal = CarTotalRaw
	end
	--Hessonite
	HesCraft = HesAmt/2
	HesHyp = HesCraft*.75*2.5
	OC_HesHypAmtLabel:SetText(HesHyp);
	HesHypRaw = HesHyp * hypnoticdust
	OC_HesHypGLabel:SetText(OC_GS(HesHypRaw, 1));
	OC_HesHypSLabel:SetText(OC_GS(HesHypRaw, 2));
	HesGce = HesCraft*.25*(2.5/3)
	OC_HesGceAmtLabel:SetText(HesGce);
	HesGceRaw = HesGce * greaterceles
	OC_HesGceGLabel:SetText(OC_GS(HesGceRaw, 1));
	OC_HesGceSLabel:SetText(OC_GS(HesGceRaw, 2));
	if OreCrusherDB.DECheck == 1 then
		HesTotalRaw = ((HesGceRaw + HesHypRaw) * ((1 + OreCrusherDB.DEPct * .01))) - (HesCraft * 12000)
	else
		HesTotalRaw = (HesGceRaw + HesHypRaw) - (HesCraft * 12000)
	end
	OC_HesTotalGLabel:SetText(OC_GS(HesTotalRaw, 1));
	OC_HesTotalSLabel:SetText(OC_GS(HesTotalRaw, 2));
	HesGemWorth = HesTotalRaw/HesAmt
	OC_HesWorthGLabel:SetText(OC_GS(HesGemWorth, 1));
	OC_HesWorthSLabel:SetText(OC_GS(HesGemWorth, 2));
	if (hessonite < 52500) and (HesGemWorth < 52500) then
		OC_HesRecLabel:SetText("Vendor Raw");
		HesTotal = HesAmt * 50000
	elseif HesGemWorth < hessonite then
		OC_HesRecLabel:SetText("Auction Raw");
		HesTotal = HesRaw
	elseif HesGemWorth > hessonite then
		OC_HesRecLabel:SetText("DE");
		HesTotal = HesTotalRaw
	end
	--Jasper Ring
	JasCraft = JasAmt
	JasHyp = JasCraft*.75*1.5
	OC_JasHypAmtLabel:SetText(JasHyp);
	JasHypRaw = JasHyp * hypnoticdust
	OC_JasHypGLabel:SetText(OC_GS(JasHypRaw, 1));
	OC_JasHypSLabel:SetText(OC_GS(JasHypRaw, 2));
	JasGce = JasCraft*.25*(1.5/3)
	OC_JasGceAmtLabel:SetText(JasGce);
	JasGceRaw = JasGce * greaterceles
	OC_JasGceGLabel:SetText(OC_GS(JasGceRaw, 1));
	OC_JasGceSLabel:SetText(OC_GS(JasGceRaw, 2));
	if OreCrusherDB.DECheck == 1 then
		JasTotalRaw = ((JasGceRaw + JasHypRaw) * ((1 + OreCrusherDB.DEPct * .01))) - (JasCraft * 12000)
	else
		JasTotalRaw = (JasGceRaw + JasHypRaw) - (JasCraft * 12000)
	end
	OC_JasTotalGLabel:SetText(OC_GS(JasTotalRaw, 1));
	OC_JasTotalSLabel:SetText(OC_GS(JasTotalRaw, 2));
	JasGemWorth = JasTotalRaw/JasAmt
	OC_JasWorthGLabel:SetText(OC_GS(JasGemWorth, 1));
	OC_JasWorthSLabel:SetText(OC_GS(JasGemWorth, 2));
	if (jasper < 52500) and (JasGemWorth < 52500) then
		OC_JasRecLabel:SetText("Vendor Raw");
		JasTotal = JasAmt * 50000
	elseif JasGemWorth < jasper then
		OC_JasRecLabel:SetText("Auction Raw");
		JasTotal = JasRaw
	elseif JasGemWorth > jasper then
		OC_JasRecLabel:SetText("DE");
		JasTotal = JasTotalRaw
	end
	--Nightstone Choker
	NigCraft = NigAmt/2
	NigHyp = NigCraft*.75*2.5
	OC_NigHypAmtLabel:SetText(NigHyp);
	NigHypRaw = NigHyp * hypnoticdust
	OC_NigHypGLabel:SetText(OC_GS(NigHypRaw, 1));
	OC_NigHypSLabel:SetText(OC_GS(NigHypRaw, 2));
	NigGce = NigCraft*.25*(2.5/3)
	OC_NigGceAmtLabel:SetText(NigGce);
	NigGceRaw = NigGce * greaterceles
	OC_NigGceGLabel:SetText(OC_GS(NigGceRaw, 1));
	OC_NigGceSLabel:SetText(OC_GS(NigGceRaw, 2));
	if OreCrusherDB.DECheck == 1 then
		NigTotalRaw = ((NigGceRaw + NigHypRaw) * ((1 + OreCrusherDB.DEPct * .01))) - (NigCraft * 12000)
	else
		NigTotalRaw = (NigGceRaw + NigHypRaw) - (NigCraft * 12000)
	end
	OC_NigTotalGLabel:SetText(OC_GS(NigTotalRaw, 1));
	OC_NigTotalSLabel:SetText(OC_GS(NigTotalRaw, 2));
	NigGemWorth = NigTotalRaw/NigAmt
	OC_NigWorthGLabel:SetText(OC_GS(NigGemWorth, 1));
	OC_NigWorthSLabel:SetText(OC_GS(NigGemWorth, 2));
	if (nightstone < 52500) and (NigGemWorth < 52500) then
		OC_NigRecLabel:SetText("Vendor Raw");
		NigTotal = NigAmt * 50000
	elseif NigGemWorth < nightstone then
		OC_NigRecLabel:SetText("Auction Raw");
		NigTotal = NigRaw
	elseif NigGemWorth > nightstone then
		OC_NigRecLabel:SetText("DE");
		NigTotal = NigTotalRaw
	end
	if (zephyrite < 52500) then
		ZepTotal = ZepAmt * 50000
		OC_ZepRecLabel:SetText("Vendor Raw");
	else
		ZepTotal = ZepRaw
		OC_ZepRecLabel:SetText("Auction Raw");
	end
	if OreCrusherDB.RareCheck == 1 then
		RareTotal = (AmbRaw + DemRaw + DreRaw + EmbRaw + InfRaw + OceRaw) * (1 + OreCrusherDB.RarePct * .01)
	else
		RareTotal = (AmbRaw + DemRaw + DreRaw + EmbRaw + InfRaw + OceRaw)
	end
	--Set total with DE label
	DETotalRaw = RareTotal + (AliTotal + CarTotal + HesTotal + JasTotal + NigTotal + ZepTotal) + VolRaw
	OC_DETotalGLabel:SetText(OC_GS(DETotalRaw, 1));
end

function OreCrusher_Xmute()
	local stdAmt = AliAmt
	if OreCrusherDB.RareCheck == 1 then
		RareTotal = (AmbRaw + DemRaw + DreRaw + EmbRaw + InfRaw + OceRaw) * (1 + OreCrusherDB.RarePct * .01)
	else
		RareTotal = (AmbRaw + DemRaw + DreRaw + EmbRaw + InfRaw + OceRaw)
	end
	if OreCrusherDB.XmuteCheck == 1 then
		XmuteAmt = ((stdAmt / 3) * 2 ) * 1.2
		RareXmuteAmt = (stdAmt / 3) * 1.2
	else
		XmuteAmt = (stdAmt / 3) * 2
		RareXmuteAmt = (stdAmt / 3)
	end
	--rare gem transmutes
	OC_WhiptailAmtLabel:SetText(stdAmt)
	OC_WhiptailGLabel:SetText(OC_GS(stdAmt * whiptail, 1));
	OC_WhiptailSLabel:SetText(OC_GS(stdAmt * whiptail, 2));
	OC_AliXAmtLabel:SetText(RareXmuteAmt);
	AliXTotalRaw = ((RareXmuteAmt * amberjewel)-(stdAmt * whiptail))
	OC_AliXTotalGLabel:SetText(OC_GS(AliXTotalRaw, 1));
	OC_AliXTotalSLabel:SetText(OC_GS(AliXTotalRaw, 2));
	OC_AliXWorthGLabel:SetText(OC_GS(AliXTotalRaw / stdAmt, 1));
	OC_AliXWorthSLabel:SetText(OC_GS(AliXTotalRaw / stdAmt, 2));
	if (alicite < 52500) and (AliXTotalRaw < 52500) then
		OC_AliXRecLabel:SetText("Vendor Raw");
		AliXTotal = stdAmt * 50000
	elseif (AliXTotalRaw / stdAmt) < alicite then
		OC_AliXRecLabel:SetText("Auction Raw");
		AliXTotal = AliRaw
	elseif (AliXTotalRaw / stdAmt) > alicite then
		OC_AliXRecLabel:SetText("Transmute");
		AliXTotal = AliXTotalRaw
	end
	--
	OC_HeartblossomAmtLabel:SetText(stdAmt)
	OC_HeartblossomGLabel:SetText(OC_GS(stdAmt * heartblossom, 1));
	OC_HeartblossomSLabel:SetText(OC_GS(stdAmt * heartblossom, 2));
	OC_CarXAmtLabel:SetText(RareXmuteAmt);
	CarXTotalRaw = ((RareXmuteAmt * infernoruby)-(stdAmt * heartblossom))
	OC_CarXTotalGLabel:SetText(OC_GS(CarXTotalRaw, 1));
	OC_CarXTotalSLabel:SetText(OC_GS(CarXTotalRaw, 2));
	OC_CarXWorthGLabel:SetText(OC_GS(CarXTotalRaw / stdAmt, 1));
	OC_CarXWorthSLabel:SetText(OC_GS(CarXTotalRaw / stdAmt, 2));
	if (carnelian < 52500) and (CarXTotalRaw / stdAmt < 52500) then
		OC_CarXRecLabel:SetText("Vendor Raw");
		CarXTotal = stdAmt * 50000
	elseif (CarXTotalRaw / stdAmt) < carnelian then
		OC_CarXRecLabel:SetText("Auction Raw");
		CarXTotal = CarRaw
	elseif (CarXTotalRaw / stdAmt) > carnelian then
		OC_CarXRecLabel:SetText("Transmute");
		CarXTotal = CarXTotalRaw
	end
	--
	OC_CinderbloomAmtLabel:SetText(stdAmt)
	OC_CinderbloomGLabel:SetText(OC_GS(stdAmt * cinderbloom, 1));
	OC_CinderbloomSLabel:SetText(OC_GS(stdAmt * cinderbloom, 2));
	OC_HesXAmtLabel:SetText(RareXmuteAmt);
	HesXTotalRaw = ((RareXmuteAmt * embertopaz)-(stdAmt * cinderbloom))
	OC_HesXTotalGLabel:SetText(OC_GS(HesXTotalRaw, 1));
	OC_HesXTotalSLabel:SetText(OC_GS(HesXTotalRawcinderbloom), 2);
	OC_HesXWorthGLabel:SetText(OC_GS(HesXTotalRaw / stdAmt, 1));
	OC_HesXWorthSLabel:SetText(OC_GS(HesXTotalRaw / stdAmt, 2));
	if (hessonite < 52500) and (HesXTotalRaw / stdAmt < 52500) then
		OC_HesXRecLabel:SetText("Vendor Raw");
		HesXTotal = stdAmt * 50000
	elseif (HesXTotalRaw / stdAmt) < hessonite then
		OC_HesXRecLabel:SetText("Auction Raw");
		HesXTotal = HesRaw
	elseif (HesXTotalRaw / stdAmt) > hessonite then
		OC_HesXRecLabel:SetText("Transmute");
		HesXTotal = HesXTotalRaw
	end
	--
	OC_StormvineAmtLabel:SetText(stdAmt)
	OC_StormvineGLabel:SetText(OC_GS(stdAmt * stormvine, 1));
	OC_StormvineSLabel:SetText(OC_GS(stdAmt * stormvine, 2));
	OC_JasXAmtLabel:SetText(RareXmuteAmt);
	JasXTotalRaw = ((RareXmuteAmt * dreamemerald)-(stdAmt * stormvine))
	OC_JasXTotalGLabel:SetText(OC_GS(JasXTotalRaw, 1));
	OC_JasXTotalSLabel:SetText(OC_GS(JasXTotalRaw, 2));
	OC_JasXWorthGLabel:SetText(OC_GS(JasXTotalRaw / stdAmt, 1));
	OC_JasXWorthSLabel:SetText(OC_GS(JasXTotalRaw / stdAmt, 2));
	if (jasper < 52500) and (JasXTotalRaw / stdAmt < 52500) then
		OC_JasXRecLabel:SetText("Vendor Raw");
		JasXTotal = stdAmt * 50000
	elseif (JasXTotalRaw / stdAmt) < jasper then
		OC_JasXRecLabel:SetText("Auction Raw");
		JasXTotal = JasRaw
	elseif (JasXTotalRaw / stdAmt) > jasper then
		OC_JasXRecLabel:SetText("Transmute");
		JasXTotal = JasXTotalRaw
	end
	--
	OC_TwilightJasmineAmtLabel:SetText(stdAmt)
	OC_TwilightJasmineGLabel:SetText(OC_GS(stdAmt * twilightjasmine, 1));
	OC_TwilightJasmineSLabel:SetText(OC_GS(stdAmt * twilightjasmine, 2));
	OC_NigXAmtLabel:SetText(RareXmuteAmt);
	NigXTotalRaw = ((RareXmuteAmt * demonseye)-(stdAmt * twilightjasmine))
	OC_NigXTotalGLabel:SetText(OC_GS(NigTotalRaw, 1));
	OC_NigXTotalSLabel:SetText(OC_GS(NigTotalRaw, 2));
	OC_NigXWorthGLabel:SetText(OC_GS(NigTotalRaw / stdAmt, 1));
	OC_NigXWorthSLabel:SetText(OC_GS(NigTotalRaw / stdAmt, 2));
	if (nightstone < 52500) and (NigTotalRaw / stdAmt < 52500) then
		OC_NigXRecLabel:SetText("Vendor Raw");
		NigXTotal = stdAmt * 50000
	elseif (NigTotalRaw / stdAmt) < nightstone then
		OC_NigXRecLabel:SetText("Auction Raw");
		NigXTotal = NigRaw
	elseif (NigTotalRaw / stdAmt) > nightstone then
		OC_NigXRecLabel:SetText("Transmute");
		NigXTotal = NigXTotalRaw
	end
	--
	OC_AzsharasVeilAmtLabel:SetText(stdAmt)
	OC_AzsharasVeilGLabel:SetText(OC_GS(stdAmt * azsharasveil, 1));
	OC_AzsharasVeilSLabel:SetText(OC_GS(stdAmt * azsharasveil, 2));
	OC_ZepXAmtLabel:SetText(RareXmuteAmt);
	ZepXTotalRaw = ((RareXmuteAmt * oceansapphire)-(stdAmt * azsharasveil))
	OC_ZepXTotalGLabel:SetText(OC_GS(ZepXTotalRaw, 1));
	OC_ZepXTotalSLabel:SetText(OC_GS(ZepXTotalRaw, 2));
	OC_ZepXWorthGLabel:SetText(OC_GS(ZepXTotalRaw / stdAmt, 1));
	OC_ZepXWorthSLabel:SetText(OC_GS(ZepXTotalRaw / stdAmt, 2));
	if (zephyrite < 52500) and (ZepXTotalRaw / stdAmt < 52500) then
		OC_ZepXRecLabel:SetText("Vendor Raw");
		ZepXTotal = stdAmt * 50000
	elseif (ZepXTotalRaw / stdAmt) < zephyrite then
		OC_ZepXRecLabel:SetText("Auction Raw");
		ZepXTotal = ZepRaw
	elseif (ZepXTotalRaw / stdAmt) > zephyrite then
		OC_ZepXRecLabel:SetText("Transmute");
		ZepXTotal = ZepXTotalRaw
	end
	--
	RareXmuteTotalRaw = RareTotal + VolRaw + (AliXTotal + CarXTotal + HesXTotal + JasXTotal + NigXTotal + ZepXTotal)
	SDXmuteTotalRaw = (XmuteAmt * shadowspirit) + RareTotal + VolRaw
	if RareXmuteTotalRaw > SDXmuteTotalRaw then
		XmuteTotalRaw = RareXmuteTotalRaw
	else
		XmuteTotalRaw = SDXmuteTotalRaw
	end
	OC_XmuteTotalGLabel:SetText(OC_GS(XmuteTotalRaw, 1));
end

function OreCrusher_MaxGold()
	if DETotalRaw < TotalRaw and XmuteTotalRaw < TotalRaw then
		OC_MaxSuggestionLabel:SetText("AH Uncommons + Rare Cuts");
		MaxGRaw = TotalRaw - ((rvPPS*rvNS)*10000) 
	elseif DETotalRaw < XmuteTotalRaw then
		OC_MaxSuggestionLabel:SetText("Transmute + Rare Cuts");
		MaxGRaw = XmuteTotalRaw - ((rvPPS*rvNS)*10000) 
	elseif DETotalRaw > XmuteTotalRaw then
		OC_MaxSuggestionLabel:SetText("DE/AH + Rare Cuts");
		MaxGRaw = DETotalRaw - ((rvPPS*rvNS)*10000) 
	end
	OC_MaxGLabel:SetText(OC_GS(MaxGRaw, 1));
end

function OreCrusher_MaxStackPrice()
	if DETotalRaw < XmuteTotalRaw then
		MaxOrePrice = XmuteTotalRaw / rvNS
	elseif DETotalRaw > XmuteTotalRaw then
		MaxOrePrice = DETotalRaw / rvNS
	end
	OC_MaxStackPriceGLabel:SetText(OC_GS(MaxOrePrice, 1));
end

function OC_GS(value, moneyType)
	if value == nil then value = 0 end
	if moneyType == 1 then
		gold = math.floor(value/10000);
		return gold or 0;
	elseif moneyType == 2 then
		silver = math.floor(strsub(value, -4)/100);
		return silver or 0;
	elseif moneyType == 3 then
		copper = math.floor(strsub(value, -2));
		return copper or 0;
	end
end

function OreCrusher_Scan()
	if OreCrusherDB.PriceDB == "OreCrusherPriceDB" then
		OreCrusher_InitAHSearch();
	else
		print("You must set your Price DB to OreCrusherPriceDB to use this feature.");
	end
end

function OreCrusher_SlashCommandHandler(msg)
    if msg == "altbuyout" then
		OreCrusherOptions:Show();
	end
	OreCrusherForm:Show();
end

function OreCrusher_Hider()
	OreCrusherForm:Hide();
	OreCrusherDE:Hide();
	OreCrusherTransmute:Hide();
	OreCrusherOptions:Hide();
end

function OreCrusher_OnLoad()
	OC_Scan:Hide();
	SlashCmdList["ORECRUSHER"] = OreCrusher_SlashCommandHandler;
	SLASH_ORECRUSHER1 = '/oc';
	SLASH_ORECRUSHER2 = '/orecrusher';
    SLASH_ORECRUSHER3 = '/theoc';
end